#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

/* Copyright (C) 1992,2000 Bisqwit (http://iki.fi/bisqwit/)
 * No warranty. You are free to modify this source, and to
 * distribute modified sources, as long as you keep the
 * existing copyright messages intact and as long as you
 * remember to add your own copyright markings.
 */

class kolikko
{
public:
	int m;         /* optimal count to give before next currency matter */
	int h;         /* value per one (100 = 1) */
	string n;      /* name */
public:
	kolikko(int mm, int hh, const string &nn) : m(mm),h(hh),n(nn)
	{
	}
};

static class kerroin : public vector<kolikko>
{
public:
	kerroin()
	{
		load("batmud.dat");
	}
	bool load(const string &fn)
	{
		FILE *fp = fopen(fn.c_str(), "rt");
		if(!fp)return false;
		char Buf[256];
		clear();
		while(fgets(Buf,sizeof Buf,fp))
		{
			const char *s = Buf;
			int n=0; while(isdigit(*s))n=n*10+*s++-'0';
			while(*s==' '||*s=='\t')++s;
			int h=0; while(isdigit(*s))h=h*10+*s++-'0';
			while(*s==' '||*s=='\t')++s;
			string ss;
			while(*s!='\n'&&*s!='\r'&&*s)ss+=*s++;
			push_back(kolikko(n,h,ss));
		}
		fclose(fp);
		return true;
	}
} kerroin;

static void InvNow(const char *hdr, int *aine)
{
	int c=0;
	unsigned a;
    printf("*** %s: ", hdr);
    for(a=0; a<kerroin.size(); ++a)
        if(aine[a])
        {
            printf("%d %s, ", aine[a], kerroin[a].n.c_str());
            c += kerroin[a].h * aine[a];
        }
    printf("that is %d.%02d...\n", c/100, c%100);
}

static int debug=1;

/* The brute force -routine */
/* Chooses often the best choice in less than ten loops... */
static int Calcul(int *aine, int *sums, int start, int hinta)
{
	unsigned a;
    for(a=start; a<kerroin.size(); ++a)
    {
        int f = kerroin[a].h, arvo = aine[a] * f, max, e, c;
        if(arvo > hinta)arvo = hinta;
        max = arvo / kerroin[a].h;
        if(!max)
        {
            sums[a] = 0;
            continue;
        }
/*      printf("Testing %s(have %d -> %d) for %d.%02d...\n",
            kerroin[a].n, aine[a], max, hinta/100, hinta%100);
*/      for(c=max, e=c*f; c>0; --c, e-=f)
        {
            if(e == hinta)
            {
                sums[a] = c;
                while(++a < kerroin.size())sums[a] = 0;
                return 1;
            }
            if(Calcul(aine, sums, a+1, hinta-e))
            {
                sums[a] = c;
                return 1;
            }
        }
/*      printf("blah\n");
*/      break;
    }
    return 0;
}

static void maksa(const char *nick, unsigned pay, int *aine, int Isot1)
{
    int kayt[kerroin.size()];
    int a, b=0, hinta=pay;

    for(a=0; a<(int)kerroin.size(); ++a)kayt[a] = 0;

/*  This is not a good idea to put yet here. Would make this too slow.
    Let's do some simple fixing first.

    if(!Calcul(aine, kayt, 0, hinta))goto diu;
*/
    if(debug)InvNow("Inv at start", aine);

    for(a=Isot1?0:kerroin.size(); Isot1?a<(int)kerroin.size():a>0; Isot1?++a:0)
    {
        unsigned e;
        if(!Isot1)--a;
        for(e=0; aine[a] && kerroin[a].h <= hinta; ++e)
        {
            --aine[a];
            ++kayt[a];
            hinta -= kerroin[a].h;
            b += kerroin[a].h;
        }
        if(e && debug)
        {
            printf("*** first: gave %u %s... so I've %d.%02d left to pay.\n",
                e, kerroin[a].n.c_str(), hinta/100, hinta%100);
        }
    }

    for(; hinta != 0; )
    {
        int kulu[kerroin.size()];
        const char *gave = "";

        if(debug)
        {
            InvNow("Inv now", aine);
            InvNow("Have gave", kayt);
        }
        for(a=kerroin.size(); --a>=0; )
        {
            if(aine[a])break;
            if(!a && hinta>0)
            {
                printf("say [batmoney] I don't have enough money to pay with.\n");
                return;
            }
        uusi:;
        }
        if(a >= 0)
        {
            int maara = kerroin[a].m, arvo;
            if(maara > aine[a])maara = aine[a];
            aine[a] -= maara;
            kayt[a] += maara;
            arvo = kerroin[a].h * maara;
            hinta -= arvo;
            b += arvo;
            if(debug)
                printf("*** exchange: gave %d %s%s (%d.%02d), now I want %d.%02d back...\n",
                    maara, kerroin[a].n.c_str(), gave,
                    arvo/100, arvo%100,
                    (-hinta)/100, (-hinta)%100);
        }
        if(!Calcul(kayt, kulu, 0, -hinta))
        {
            if(a>0)
            {
                gave = " more";
                goto uusi;
            }
            if(debug)
                printf("*** exchange: didn't help... getting cash back.\n");
            break;
        }

        for(a=0; a < (int)kerroin.size(); ++a)
        {
            int c = kulu[a]*kerroin[a].h;
            if(kulu[a])
            {
                if(debug)
                    printf("*** exchange: took back %u %s (%d.%02d)...\n",
                        kulu[a], kerroin[a].n.c_str(),
                        c/100, c%100);
                kayt[a] -= kulu[a];
                aine[a] += kulu[a];
                hinta += c;
                b -= c;
            }
        }
    }

    for(a=0; a < (int)kerroin.size(); ++a)
    {
        unsigned e;
        for(e=0; kayt[a] && kerroin[a].h <= -hinta; ++e)
        {
            ++aine[a];
            --kayt[a];
            hinta += kerroin[a].h;
            b -= kerroin[a].h;
        }
        if(e && debug)
            printf("*** last: took %u %s... I still need to reget %d.%02d.\n",
                e, kerroin[a].n.c_str(),
                (-hinta)/100, (-hinta)%100);
    }
/*
diu:*/
    if(debug)
    {
        printf("-----------\n");

        InvNow("Inv now", aine);
        InvNow("Have gave", kayt);

        printf("-----------\n");
    }
    
    {int c=0;
    for(a=0; a<(int)kerroin.size(); ++a)
        if(kayt[a])
        {
            if(nick)
                printf("give %d %s to %s\n", kayt[a], kerroin[a].n.c_str(), nick);
            else
                printf("drop %d %s\n", kayt[a], kerroin[a].n.c_str());
            ++c;
        }

    printf("emote calculates: %s ", nick?"Paid":"Dropped");
    for(a=0; a<(int)kerroin.size(); ++a)
        if(kayt[a])
        {
            printf("%d %s", kayt[a], kerroin[a].n.c_str());
            --c;
        	if(c==1)printf(" and ");else if(c>1)printf(", ");
        }}

    printf(", totalling worth of %d.%02d.\n", b/100, b%100);

    if(hinta < 0)
    {
        hinta = -hinta;
        printf("say [batmoney] I ran out of small coins, I want %d.%02d back.\n", hinta/100, hinta%100);
    }

    if(debug)
        printf("-----------\n");
}

static void ParseInventory(char *inv, int *aine)
{
    int a, b=kerroin.size(), l=0;
    for(a=0; a<b; ++a)aine[a]=0;
    while(*inv && *inv!=')')
    {
        int n = strtol(inv, &inv, 10);
        while(*inv==' ')++inv;
        for(a=0; a<b; ++a)
        {
            l = kerroin[a].n.size();
            if(!strncmp(inv, kerroin[a].n.c_str(), l))break;
        }
        if(a==b)
        {
            printf("say [batmoney] Money inventory parse error at '%s'\n", inv);
            exit(-1);
        }
        aine[a] = n;
        inv += l;
        if(*inv == ',')++inv;
        if(!strncmp(inv, " and", 4))inv += 4;
        while(*inv==' ')++inv;
    }
}

int main(int argc, const char *const *argv)
{
    char Buf[512];
    char Money[2048];

    kerroin.load("batmud.dat");

    int aine[kerroin.size()];
    
    const char *nick = NULL;
    int amount = -1;
    int isot = 0;
    int a;

    while(--argc)
    {
        const char *s = *++argv;

        if(*s=='-')
        {
            while(*++s)
            {
                switch(*s)
                {
                    case 'd':
                        debug=1;
                        break;
                    case 'q':
                        debug=0;
                        break;
                    case 'b':
                        isot=1;
                        break;
                    default:
                    usage:
                        printf(
                        	"Version: "VERSION"\n"
                            "Pay calculator for the unique BatMUD's monetary system.\n\n"
                            "Usage: pay [-q] [-d] [-b] [<nick>] <amount>\n"
                            "    -d  Debug info (for algorithm investigators) (default)\n"
                            "    -q  Disables -d (makes quiet)\n"
                            "    -b  Pay using biggest coins ""(default: smallest coins)\n"
                            "Example: pay bisqwit 10000\n"
                            "\n"
                            "Copyright (C) 1992,2000 Bisqwit (http://iki.fi/bisqwit/)\n"
                        );
                        return 0;
                }
            }
        }
        else if(!nick)
            nick = s;
        else
        {
            if(amount >= 0)
                goto usage;
            amount = static_cast<int>(strtod(s, (char **)&s) * 100 + 0.5);
            if(*s || amount < 0)goto usage;
        }
    }
    if(amount == -1 && nick)
    {
        const char *s;
        amount = static_cast<int>(strtod(nick, (char **)&s) * 100 + 0.5);
        if(*s)goto usage;
        nick = NULL;
    }
    if(amount < 0)goto usage;

    if(debug)
        printf("*** Now paste your inventory here (the lines saying what coins do you have):\n");

    for(a=0; fgets(Buf,511,stdin); )
    {
        char *s;
        strtok(Buf, "\n");
        strtok(Buf, "\r");
         /* so that this source can be used as input */
        if(!a && strstr(Buf, "coi""ns ("))
        {
            a=1;
            strcpy(Money, strchr(Buf, '(')+1);
        }
        if(a)
        {
            s = strchr(Buf, ')');
            if(s)a += 2;
            if(a==1)
                a=2;
            else
            {
                if(a==2 || a==4)strcat(Money, Buf);
                if(a >= 3)
                {
                    if(debug)
                        printf("*** Thank you\n");
                    a=0;
                    break;
                }
            }
        }
    }
    if(a)
        printf("say [batmoney] Unexpected end of input.\n");

    ParseInventory(Money, aine);

    maksa(nick, amount, aine, isot);

    return 0;
}

/*

You are carrying 20.0 kg of equipment:
4049 coins (402 mithril, 91 batium, 69 anipium, 53 platinum, 1155 gold, 267
 silver, 106 bronze, 133 copper, 212 tin, 361 zinc and 1200 mowgles) [Cash:
 215515  Bank: 1  Total: 215516]

From: Bisqwit
Subject: A product of creativity
Date: Sun Mar 26 11:13:15 2000 (postedited)
Reply-Code: 24le
Lines: 17
Like if I had nothing better to do, I coded a bit.

http://iki.fi/bisqwit/src/batmoney.c is the sourcecode
of a program, which you can use to calculate money sums
in BatMUD. Complete description is found at
http://iki.fi/bisqwit/notes.shtml?algomoney .

Shortly:
If you want to pay a sum of cash and you have a various
collection of coins, you can use this program to calculate
what coins do you give. It creates a list of commands for
giving the coins away. You can either give the smallest
coins or the biggest coins you have.

It even handles the cases when you don't have enough money
(no it does not go to bank), or you have no suitable coins.

*/
